require 'wc_monitor/version'
require 'logger'

module WcMonitor
  require 'wc_monitor/controller'
  require 'wc_monitor/active_record'

  class Railtie < Rails::Railtie
    initializer 'wc_monitor.initializer' do
      ActiveSupport.on_load(:action_controller) do
        include WcMonitor::ControllerMethods
      end

      ActiveSupport.on_load(:active_record) do
        include WcMonitor::ModelMethods
      end
    end
  end

  def self.registry
    @registry ||= []
  end

  def self.clear_registry
    @registry = []
  end

  def self.logger
    @logger ||= Logger.new(Rails.root.join('log', 'wc_monitor.log'))
  end
end
